<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>SRN CFD</title>
    <script type="text/javascript" async
      src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.7/MathJax.js?config=TeX-MML-AM_CHTML">
    </script>
    <style>
        body {
            font-family: 'Segoe UI', Tahoma, Geneva, Verdana, sans-serif;
            text-align: center;
            margin: 20px;
            background-color: #f8f9fa; 
            color: #495057;
        }

        h1 {
            color: #005bbd;
            font-style: italic;
            text-align: center;
            margin-bottom: 20px;
            font-size: 2.5em;
        }

        section {
            margin: 40px;
        }

        p, a {
            font-size: 1.2em;
            margin: 10px 0;
            margin-bottom: 40px;
            text-align: justify;
        }

        figcaption {
            font-size: 1.2em; 
            font-weight: bold;
            color: #333; 
            margin: 5px; 
            text-align: center; 
        }

        form {
            display: flex;
            flex-direction: column;
            align-items: center;
            background-color: #fff;
            padding: 20px;
            border-radius: 8px;
            box-shadow: 0 0 10px rgba(0, 0, 0, 0.1);
        }

        label {
            margin: 10px;
            font-size: 1.2em;
            color: #007bff;
        }

        input {
            margin: 5px;
            padding: 10px;
            font-size: 1em;
            text-align: left;
            border: 1px solid #ced4da;
            border-radius: 5px;
            width: 100%;
            box-sizing: border-box;
        }
        
        /* Add loading spinner styles */
        #loading_spinner {
            display: none;
            border: 4px solid rgba(0, 0, 0, 0.1);
            border-top: 4px solid #007bff;
            border-radius: 50%;
            width: 20px;
            height: 20px;
            animation: spin 1s linear infinite;
        }
    
        @keyframes spin {
            0% { transform: rotate(0deg); }
            100% { transform: rotate(360deg); }
        }
    
        /* Enhance button styling */
        button {
            margin: 10px;
            padding: 10px 20px;
            font-size: 1em;
            text-align: center;
            background-color: #007bff;
            color: #fff;
            border: none;
            border-radius: 5px;
            cursor: pointer;
            transition: background-color 0.3s ease-in-out;
        }
    
        button:hover {
            background-color: #0056b3;
        }

        #image-container {
            display: flex;
            justify-content: center;
        }

        .side-by-side-image {
            width: auto;
            height: 200px; /* Set the desired height */
            margin: 0 10px; /* Adjust as needed */
        }

        .row {
            display: flex;
        }

        .column {
            flex: 40%;
            padding: 5px;
        }

    </style>
</head>
<body>

    <img src="{{ url_for('static', filename='logos.png') }}" alt="FZJulich" style="height: 40px; margin-left: 10px; width: auto; float: right;" class="side-by-side-image" id="julich-logo">

    <br>
    <br>

    <h1>
        Super Resolution Network for CFD of Nasal Cavity Flows
    </h1>
    
    <hr>

    <section>
        <h2> Abstract </h2>
        
        <p>
            Accurately predicting the flow in the nasal cavity with computational fluid dynamics (CFD) simulations requires highly resolved computational meshes based on anatomically realistic geometries. Such geometries can only be obtained from computer tomography (CT) data with high spatial resolution, i.e., featuring a \(\leq 1~mm\) slice thickness. In practice, CTs are, however, recorded at a lower resolution to not expose patients to high radiation and to reduce the overall costs. To overcome this problem and to provide patients with a detailed physics-based diagnosis, e.g., for surgery planning, the potential of super-resolution networks (SRNs) to increase the CT resolution is analyzed. Therefore, an SRN is developed and trained on CT data. Its predictive performance is improved by an automated hyperparameter optimization technique. The training time is further reduced without predictive accuracy degradation by oversampling images with challenging regions. The performance of the SRN is assessed by an analysis of the reconstructed 3D surfaces of the human upper airway and by comparing results of CFD simulations. That is, surfaces and simulation results based on SRN-generated CT data at \(1~mm\) resolution are compared to those obtained from unmodified CT data-sets at low (\(3~mm\)) and high (\(1~mm\)) resolution, as well as from CT data interpolated to a \(1~mm\) resolution from coarse data. The findings reveal the SRN-based approach to have the lowest deviations in the physics-based CFD results when compared to those based on the original high-resolution data. The pressure loss between the inflow (nostrils) and outflow (pharynx) regions averaged for three test patients differs by only \(1.3\%\), compared to \(8.7\%\) and \(8.8\%\) in the coarse and interpolated cases. It is concluded that the SRN-based method is a promising tool to enhance underresolved CT data to yield reliable numerical results of respiratory flows.
        </p>

    </section>

    <section>
        <h2> Architecture </h2>
        
        <img src="{{ url_for('static', filename='res_unet.png') }}" alt="Architecture" style="max-width: 70%;" id="architecture">       

    </section>
    

    <!-- Styling the input and predict buttons -->
    <form action="/predict" method="post" enctype="multipart/form-data">
        <p for="input_file">Choose Input File:</p>
        <input style="font-size: 1.2em; margin: 10px; text-align: center;" type="file" name="input_file" accept=".npy" id="input_file" required>
        <div id="loading_spinner"></div>
        <button style="font-size: 1.2em; margin: 10px; text-align: center;" type="submit">Predict</button>

        <p id="download_link" {% if not predictions_available %}style="display: none;"{% endif %}>
            <span style="display: inline-block; text-align: center; margin-top: 10px; box-shadow: 2px 2px 5px rgba(0, 0, 0, 0.2); border-radius: 5px; padding: 5px; color: red; font-weight: bold;">
                Download the predictions from <a href="{{ url_for('download_file', filename=download_filename) }}" style="color: red; text-decoration: underline; border-bottom: none;">here</a>.
            </span>
        </p>
 
    </form>

  
    <!-- Show input and prediction images -->
    <p {% if not predictions_available %}style="display: none;"{% endif %}>

        <div class="row">
            <div class="column">
                <figure>
                    <img {% if not predictions_available %}style="display: none;"{% endif %} src="{{ url_for('input_image', filename=input_fig) }}" alt="Original Image" id="original-image" style="width:70%">
                    <figcaption {% if not predictions_available %}style="display: none;"{% endif %}> Random Slice selected from input test data </figcaption>
                </figure>
            </div>
            <div class="column">
                <figure> 
                    <img {% if not predictions_available %}style="display: none;"{% endif %} src="{{ url_for('predictions_image', filename=output_fig) }}" alt="Predicted Image" id="predicted-image" style="width:70%">
                    <figcaption {% if not predictions_available %}style="display: none;"{% endif %}> Corresponding predicted image </figcaption>
                </figure>
            </div>
        </div>
    </p> 


    <script src="https://code.jquery.com/jquery-3.6.4.min.js"></script>
    <script>
        // Update the button and spinner states during prediction
        function updatePredictionState(isPredicting) {
            if (isPredicting) {
                // Show loading spinner and disable the button
                $('#loading_spinner').show();
                $('#predict_button').prop('disabled', true);
            } else {
                // Hide loading spinner and enable the button
                $('#loading_spinner').hide();
                $('#predict_button').prop('disabled', false);
            }
        }

        // Listen for form submission
        $('form').submit(function () {
            // Show loading spinner during prediction
            updatePredictionState(true);
        });
    
        // Listen for file input change event
        $('#input_file').change(function() {
            // Hide the download link when a new file is selected
            $('#download_link').hide();
        });

    </script>
</body>
</html>